/** Store information about the ball.
 * The information included, the placement of the ball, current velocity and direction, 
 * aswell as its size, point value and horisontal movement
 */

import java.awt.Graphics;

public class Ball {
	

	
	private int ballSize = 0;
	private int ballPxlSize = 0;
	private int ballBounceSize;
	private int ballPointValue;
	
	private int x = 0;
	private int y = 0;
	
	private int lastX = 0;
	private int lastY = 0;
	
	private int s = 0;
	private double v;
	private double u;
	private int initialVelocity;
	private double horDirection;
	private double scale;
	
	private int type;
	
	private int alive;

	public Ball (int x, int y, int ballSize, int initialVelocity, double horDirection, int type, double scale) {
		this.scale = scale;
		this.type = type;
		// Initialize all of the variables
		this.x = x;
		this.y = y;
		this.ballSize = ballSize;
		
		resetBallSizes();

		this.horDirection = horDirection;
		this.initialVelocity = initialVelocity;

		u = initialVelocity;
//		System.out.println(initialVelocity);
//		System.out.println(horDirection);
		
		alive = 1;
//		System.out.println(toString());
	}
	
	public void resetBallSizes() {

	
		if (ballSize == 1) {
			ballPxlSize = 8;
			ballBounceSize = 30;
			ballPointValue = 400;
		} else if (ballSize == 2) {
			ballPxlSize = 16;
			ballBounceSize = 40;
			ballPointValue = 200;
		} else if (ballSize == 3) {
			ballPxlSize = 32;
			ballBounceSize = 50;
			ballPointValue = 100;
		} else if (ballSize == 4) {
			ballPxlSize = 41;
			ballBounceSize = 60;
			ballPointValue = 50;
		}

		ballPxlSize = scaleAndRound(ballPxlSize);
		ballBounceSize = halfScaleAndRound(ballBounceSize);


	}
	public int getBallPxlSize () {
		return ballPxlSize;
	}
	
	public void update (int x, int y, double v, int s, int horDirection) {
		this.x = x;
		this.y = y;
		this.v = v;
		this.s = s;
		this.horDirection = horDirection;
	}
	

	public void drawBall (BallGenPanel pane) {
	
		if (ballSize == 1) pane.g.drawImage(pane.ballImage, x, y, x + ballPxlSize, y + ballPxlSize, 1, 1,9, 9,null);
		if (ballSize == 2) pane.g.drawImage(pane.ballImage, x, y, x + ballPxlSize, y + ballPxlSize, 1, 10, 17, 26,null);
		if (ballSize == 3) pane.g.drawImage(pane.ballImage, x, y, x + ballPxlSize, y + ballPxlSize, 1, 27, 33, 59,null);						
		if (ballSize == 4) pane.g.drawImage(pane.ballImage, x, y, x + ballPxlSize, y + ballPxlSize, 1, 60, 42, 101,null);
	
	}
	
	
	public void setX (int x) {
		this.x = x;
	}
	public void setY (int y) {
		this.y = y;
	}
	public void setBallSize (int size) {
		ballSize = size;
		resetBallSizes();
	}
	
	//Getter Methods
	public int getU () {
		return (int) u;
	}
	public int getX () {
		return x;
	}
	public int getLastX () {
		return lastX;
	}
	public int getY () {
		return y;
	}
	public int getLastY () {
		return lastY;
	}
	public double getV () {
		return v;
	}
	public int getS () {
		return s;
	}
	public double getHorDirection () {
		return horDirection;
	}	
	public int getBallSize () {
		return ballSize;
	}
	public int getBallPointValue() {
		return ballPointValue;
	}
//	public String toString() {
//		return "ball:" + x;
//	}


	public int scaleAndRound (int number) {
		return (int) Math.round(number * scale);
	}

	public int halfScaleAndRound (int number) {
		if (scale < 2) {
			return number;
		} else {
			return number + scaleAndRound(8)-8;//(int) Math.round(number * scale /2);
		}
	}
	
	public String toString() {
		//B 300,20,4,0,-1
		return "B " + x + "," + y + "," + ballSize + "," + initialVelocity + "," + horDirection + "," + type;
	}

}
	
